diff --git a/web/pgadmin/tools/sqleditor/tests/test_download_csv_query_tool.py b/web/pgadmin/tools/sqleditor/tests/test_download_csv_query_tool.py
index f609193ce..bae8fb7e2 100644
--- a/web/pgadmin/tools/sqleditor/tests/test_download_csv_query_tool.py
+++ b/web/pgadmin/tools/sqleditor/tests/test_download_csv_query_tool.py
@@ -27,7 +27,7 @@ class TestDownloadCSV(BaseTestGenerator):
             'Download csv URL with valid query',
             dict(
                 sql='SELECT 1 as "A",2 as "B",3 as "C"',
-                init_url='/datagrid/initialize/query_tool/{0}/{1}/{2}/{3}',
+                init_url='/sqleditor/initialize/sqleditor/{0}/{1}/{2}/{3}',
                 donwload_url="/sqleditor/query_tool/download/{0}",
                 output_columns='"A","B","C"',
                 output_values='1,2,3',
@@ -41,7 +41,7 @@ class TestDownloadCSV(BaseTestGenerator):
             'Download csv URL with wrong TX id',
             dict(
                 sql='SELECT 1 as "A",2 as "B",3 as "C"',
-                init_url='/datagrid/initialize/query_tool/{0}/{1}/{2}/{3}',
+                init_url='/sqleditor/initialize/sqleditor/{0}/{1}/{2}/{3}',
                 donwload_url="/sqleditor/query_tool/download/{0}",
                 output_columns=None,
                 output_values=None,
@@ -55,7 +55,7 @@ class TestDownloadCSV(BaseTestGenerator):
             'Download csv URL with wrong query',
             dict(
                 sql='SELECT * FROM this_table_does_not_exist',
-                init_url='/datagrid/initialize/query_tool/{0}/{1}/{2}/{3}',
+                init_url='/sqleditor/initialize/sqleditor/{0}/{1}/{2}/{3}',
                 donwload_url="/sqleditor/query_tool/download/{0}",
                 output_columns=None,
                 output_values=None,
@@ -69,7 +69,7 @@ class TestDownloadCSV(BaseTestGenerator):
             'Download as txt without filename parameter',
             dict(
                 sql='SELECT 1 as "A",2 as "B",3 as "C"',
-                init_url='/datagrid/initialize/query_tool/{0}/{1}/{2}/{3}',
+                init_url='/sqleditor/initialize/sqleditor/{0}/{1}/{2}/{3}',
                 donwload_url="/sqleditor/query_tool/download/{0}",
                 output_columns='"A";"B";"C"',
                 output_values='1;2;3',
@@ -83,7 +83,7 @@ class TestDownloadCSV(BaseTestGenerator):
             'Download as csv without filename parameter',
             dict(
                 sql='SELECT 1 as "A",2 as "B",3 as "C"',
-                init_url='/datagrid/initialize/query_tool/{0}/{1}/{2}/{3}',
+                init_url='/sqleditor/initialize/sqleditor/{0}/{1}/{2}/{3}',
                 donwload_url="/sqleditor/query_tool/download/{0}",
                 output_columns='"A","B","C"',
                 output_values='1,2,3',
@@ -211,7 +211,7 @@ class TestDownloadCSV(BaseTestGenerator):
                 self.assertEqual(response.status_code, 500)
 
         # Close query tool
-        url = '/datagrid/close/{0}'.format(self.trans_id)
+        url = '/sqleditor/close/{0}'.format(self.trans_id)
         response = self.tester.delete(url)
         self.assertEqual(response.status_code, 200)
 
diff --git a/web/pgadmin/tools/sqleditor/tests/test_editor_history.py b/web/pgadmin/tools/sqleditor/tests/test_editor_history.py
index 86b5d935b..c7dcbdad0 100644
--- a/web/pgadmin/tools/sqleditor/tests/test_editor_history.py
+++ b/web/pgadmin/tools/sqleditor/tests/test_editor_history.py
@@ -70,7 +70,7 @@ class TestEditorHistory(BaseTestGenerator):
 
         # Initialize query tool
         self.trans_id = str(random.randint(1, 9999999))
-        url = '/datagrid/initialize/query_tool/{0}/{1}/{2}/{3}'.format(
+        url = '/sqleditor/initialize/sqleditor/{0}/{1}/{2}/{3}'.format(
             self.trans_id, utils.SERVER_GROUP, self.server_id, self.db_id)
         response = self.tester.post(url)
         self.assertEqual(response.status_code, 200)
@@ -101,7 +101,7 @@ class TestEditorHistory(BaseTestGenerator):
 
     def tearDown(self):
         # Close query tool
-        url = '/datagrid/close/{0}'.format(self.trans_id)
+        url = '/sqleditor/close/{0}'.format(self.trans_id)
         response = self.tester.delete(url)
         self.assertEqual(response.status_code, 200)
 
diff --git a/web/pgadmin/tools/sqleditor/tests/test_encoding_charset.py b/web/pgadmin/tools/sqleditor/tests/test_encoding_charset.py
index 99ec32a49..653ddac10 100644
--- a/web/pgadmin/tools/sqleditor/tests/test_encoding_charset.py
+++ b/web/pgadmin/tools/sqleditor/tests/test_encoding_charset.py
@@ -262,7 +262,7 @@ class TestEncodingCharset(BaseTestGenerator):
 
         # Initialize query tool
         self.trans_id = str(random.randint(1, 9999999))
-        url = '/datagrid/initialize/query_tool/{0}/{1}/{2}/{3}'\
+        url = '/sqleditor/initialize/sqleditor/{0}/{1}/{2}/{3}'\
             .format(self.trans_id, test_utils.SERVER_GROUP, self.encode_sid,
                     self.encode_did)
         response = self.tester.post(url)
@@ -283,7 +283,7 @@ class TestEncodingCharset(BaseTestGenerator):
         self.assertEqual(result, self.test_str)
 
         # Close query tool
-        url = '/datagrid/close/{0}'.format(self.trans_id)
+        url = '/sqleditor/close/{0}'.format(self.trans_id)
         response = self.tester.delete(url)
         self.assertEqual(response.status_code, 200)
 
diff --git a/web/pgadmin/tools/sqleditor/tests/test_explain_plan.py b/web/pgadmin/tools/sqleditor/tests/test_explain_plan.py
index 734125399..e2bfc259a 100644
--- a/web/pgadmin/tools/sqleditor/tests/test_explain_plan.py
+++ b/web/pgadmin/tools/sqleditor/tests/test_explain_plan.py
@@ -34,7 +34,7 @@ class TestExplainPlan(BaseTestGenerator):
 
         # Initialize query tool
         self.trans_id = str(random.randint(1, 9999999))
-        url = '/datagrid/initialize/query_tool/{0}/{1}/{2}/{3}'.format(
+        url = '/sqleditor/initialize/sqleditor/{0}/{1}/{2}/{3}'.format(
             self.trans_id, utils.SERVER_GROUP, self.server_id, self.db_id)
         response = self.tester.post(url)
         self.assertEqual(response.status_code, 200)
@@ -68,7 +68,7 @@ class TestExplainPlan(BaseTestGenerator):
         self.assertEqual(len(response_data['data']['result'][0]), 1)
 
         # Close query tool
-        url = '/datagrid/close/{0}'.format(self.trans_id)
+        url = '/sqleditor/close/{0}'.format(self.trans_id)
         response = self.tester.delete(url)
         self.assertEqual(response.status_code, 200)
 
diff --git a/web/pgadmin/tools/sqleditor/tests/test_macros.py b/web/pgadmin/tools/sqleditor/tests/test_macros.py
index b66678668..95e41ccb8 100644
--- a/web/pgadmin/tools/sqleditor/tests/test_macros.py
+++ b/web/pgadmin/tools/sqleditor/tests/test_macros.py
@@ -106,7 +106,7 @@ class TestMacros(BaseTestGenerator):
 
         # Initialize query tool
         self.trans_id = str(random.randint(1, 9999999))
-        url = '/datagrid/initialize/query_tool/{0}/{1}/{2}/{3}'.format(
+        url = '/sqleditor/initialize/sqleditor/{0}/{1}/{2}/{3}'.format(
             self.trans_id, utils.SERVER_GROUP, self.server_id, self.db_id)
         response = self.tester.post(url)
         self.assertEqual(response.status_code, 200)
@@ -150,7 +150,7 @@ class TestMacros(BaseTestGenerator):
 
     def tearDown(self):
         # Close query tool
-        url = '/datagrid/close/{0}'.format(self.trans_id)
+        url = '/sqleditor/close/{0}'.format(self.trans_id)
         response = self.tester.delete(url)
         self.assertEqual(response.status_code, 200)
 
diff --git a/web/pgadmin/tools/sqleditor/tests/test_poll_query_tool.py b/web/pgadmin/tools/sqleditor/tests/test_poll_query_tool.py
index 920839e56..d35a2bb73 100644
--- a/web/pgadmin/tools/sqleditor/tests/test_poll_query_tool.py
+++ b/web/pgadmin/tools/sqleditor/tests/test_poll_query_tool.py
@@ -77,7 +77,7 @@ NOTICE:  Hello, world!
 
         # Initialize query tool
         self.trans_id = str(random.randint(1, 9999999))
-        url = '/datagrid/initialize/query_tool/{0}/{1}/{2}/{3}'.format(
+        url = '/sqleditor/initialize/sqleditor/{0}/{1}/{2}/{3}'.format(
             self.trans_id, utils.SERVER_GROUP, self.server_id, self.db_id)
         response = self.tester.post(url)
         self.assertEqual(response.status_code, 200)
@@ -110,7 +110,7 @@ NOTICE:  Hello, world!
             cnt += 1
 
         # Close query tool
-        url = '/datagrid/close/{0}'.format(self.trans_id)
+        url = '/sqleditor/close/{0}'.format(self.trans_id)
         response = self.tester.delete(url)
         self.assertEqual(response.status_code, 200)
 
diff --git a/web/pgadmin/tools/sqleditor/tests/test_transaction_status.py b/web/pgadmin/tools/sqleditor/tests/test_transaction_status.py
index 5fbe83734..353820bf0 100644
--- a/web/pgadmin/tools/sqleditor/tests/test_transaction_status.py
+++ b/web/pgadmin/tools/sqleditor/tests/test_transaction_status.py
@@ -304,7 +304,7 @@ class TestTransactionControl(BaseTestGenerator):
 
     def _initialize_query_tool(self):
         self.trans_id = str(random.randint(1, 9999999))
-        url = '/datagrid/initialize/query_tool/{0}/{1}/{2}/{3}'.format(
+        url = '/sqleditor/initialize/sqleditor/{0}/{1}/{2}/{3}'.format(
             self.trans_id, utils.SERVER_GROUP, self.server_id, self.db_id)
         response = self.tester.post(url)
         self.assertEqual(response.status_code, 200)
@@ -339,6 +339,6 @@ class TestTransactionControl(BaseTestGenerator):
         utils.create_table_with_query(self.server, self.db_name, create_sql)
 
     def _close_query_tool(self):
-        url = '/datagrid/close/{0}'.format(self.trans_id)
+        url = '/sqleditor/close/{0}'.format(self.trans_id)
         response = self.tester.delete(url)
         self.assertEqual(response.status_code, 200)
diff --git a/web/pgadmin/tools/sqleditor/tests/test_view_data.py b/web/pgadmin/tools/sqleditor/tests/test_view_data.py
index b87b3604a..5ad75d28f 100644
--- a/web/pgadmin/tools/sqleditor/tests/test_view_data.py
+++ b/web/pgadmin/tools/sqleditor/tests/test_view_data.py
@@ -97,7 +97,7 @@ class TestViewData(BaseTestGenerator):
 
         # Initialize query tool
         self.trans_id = str(random.randint(1, 9999999))
-        url = '/datagrid/initialize/datagrid/{0}/3/table/{1}/{2}/{3}/{4}' \
+        url = '/sqleditor/initialize/viewdata/{0}/3/table/{1}/{2}/{3}/{4}' \
             .format(self.trans_id, test_utils.SERVER_GROUP, self.server_id,
                     self.db_id, table_id)
 
diff --git a/web/pgadmin/tools/sqleditor/utils/macros.py b/web/pgadmin/tools/sqleditor/utils/macros.py
index bdf3ec9bd..7e2f8731e 100644
--- a/web/pgadmin/tools/sqleditor/utils/macros.py
+++ b/web/pgadmin/tools/sqleditor/utils/macros.py
@@ -76,7 +76,8 @@ def get_user_macros():
     macros = db.session.query(UserMacros.name,
                               Macros.id,
                               Macros.alt, Macros.control,
-                              Macros.key, Macros.key_code
+                              Macros.key, Macros.key_code,
+                              UserMacros.sql
                               ).outerjoin(
         Macros, UserMacros.mid == Macros.id).filter(
         UserMacros.uid == current_user.id).order_by(UserMacros.name).all()
@@ -87,7 +88,8 @@ def get_user_macros():
         key_label = 'Ctrl + ' + m[4] if m[3] is True else 'Alt + ' + m[4]
         data.append({'name': m[0], 'id': m[1], 'key': m[4],
                      'key_label': key_label, 'alt': 1 if m[2] else 0,
-                     'control': 1 if m[3] else 0, 'key_code': m[5]})
+                     'control': 1 if m[3] else 0, 'key_code': m[5],
+                     'sql': m[6]})
 
     return data
 
@@ -121,7 +123,8 @@ def set_macros():
                 return make_json_response(
                     status=410, success=0, errormsg=msg
                 )
-    return ajax_response(status=200)
+
+    return get_macros(None, True)
 
 
 def create_macro(macro):
diff --git a/web/pgadmin/tools/sqleditor/utils/query_history.py b/web/pgadmin/tools/sqleditor/utils/query_history.py
index cf5e5f0b5..47e35e79a 100644
--- a/web/pgadmin/tools/sqleditor/utils/query_history.py
+++ b/web/pgadmin/tools/sqleditor/utils/query_history.py
@@ -1,6 +1,7 @@
 from pgadmin.utils.ajax import make_json_response
 from pgadmin.model import db, QueryHistoryModel
 from config import MAX_QUERY_HIST_STORED
+import json
 
 
 class QueryHistory:
@@ -107,30 +108,34 @@ class QueryHistory:
         )
 
     @staticmethod
-    def clear_history(uid, sid, dbname=None):
+    def clear_history(uid, sid, dbname=None, filter=None):
         try:
+            filters = [
+                QueryHistoryModel.uid == uid,
+                QueryHistoryModel.sid == sid
+            ]
             if dbname is not None:
-                db.session.query(QueryHistoryModel) \
-                    .filter(QueryHistoryModel.uid == uid,
-                            QueryHistoryModel.sid == sid,
-                            QueryHistoryModel.dbname == dbname) \
-                    .delete()
-
-                db.session.commit()
+                filters.append(QueryHistoryModel.dbname == dbname)
+
+            history = db.session.query(QueryHistoryModel) \
+                .filter(*filters)
+            if filter is not None:
+                for row in history:
+                    query_info = json.loads(row.query_info.decode())
+                    if query_info['query'] == filter['query'] and \
+                            query_info['start_time'] == filter['start_time']:
+                        db.session.delete(row)
             else:
-                db.session.query(QueryHistoryModel) \
-                    .filter(QueryHistoryModel.uid == uid,
-                            QueryHistoryModel.sid == sid)\
-                    .delete()
+                history.delete()
 
-                db.session.commit()
+            db.session.commit()
         except Exception:
             db.session.rollback()
             # do not affect query execution if history clear fails
 
     @staticmethod
-    def clear(uid, sid, dbname=None):
-        QueryHistory.clear_history(uid, sid, dbname)
+    def clear(uid, sid, dbname=None, filter=None):
+        QueryHistory.clear_history(uid, sid, dbname, filter)
         return make_json_response(
             data={
                 'status': True,
diff --git a/web/pgadmin/tools/sqleditor/utils/query_tool_preferences.py b/web/pgadmin/tools/sqleditor/utils/query_tool_preferences.py
index b18145e0f..ace48392f 100644
--- a/web/pgadmin/tools/sqleditor/utils/query_tool_preferences.py
+++ b/web/pgadmin/tools/sqleditor/utils/query_tool_preferences.py
@@ -18,22 +18,6 @@ from pgadmin.utils import SHORTCUT_FIELDS as shortcut_fields, \
 
 
 def register_query_tool_preferences(self):
-
-    self.info_notifier_timeout = self.preference.register(
-        'display', 'info_notifier_timeout',
-        gettext("Query info notifier timeout"), 'integer', 5,
-        category_label=PREF_LABEL_DISPLAY,
-        min_val=-1,
-        max_val=999999,
-        help_str=gettext(
-            'The length of time to display the query info notifier after '
-            'execution has completed. A value of -1 disables the notifier'
-            ' and a value of 0 displays it until clicked. Values greater'
-            ' than 0 display the notifier for the number of seconds'
-            ' specified.'
-        )
-    )
-
     self.explain_verbose = self.preference.register(
         'Explain', 'explain_verbose',
         gettext("Verbose output?"), 'boolean', False,
@@ -128,7 +112,7 @@ def register_query_tool_preferences(self):
         )
     )
 
-    self.show_prompt_commit_transaction = self.preference.register(
+    self.copy_sql_to_query_tool = self.preference.register(
         'Options', 'copy_sql_to_query_tool',
         gettext("Copy SQL from main window to query tool?"), 'boolean',
         False,
@@ -411,6 +395,24 @@ def register_query_tool_preferences(self):
         fields=shortcut_fields
     )
 
+    self.preference.register(
+        'keyboard_shortcuts',
+        'clear_query',
+        gettext('Clear query'),
+        'keyboardshortcut',
+        {
+            'alt': True,
+            'shift': False,
+            'control': True,
+            'key': {
+                'key_code': 76,
+                'char': 'L'
+            }
+        },
+        category_label=PREF_LABEL_KEYBOARD_SHORTCUTS,
+        fields=shortcut_fields
+    )
+
     self.preference.register(
         'keyboard_shortcuts',
         'download_results',
@@ -614,19 +616,6 @@ def register_query_tool_preferences(self):
         fields=accesskey_fields
     )
 
-    self.preference.register(
-        'keyboard_shortcuts', 'btn_clear_options',
-        gettext('Accesskey (Clear editor options)'), 'keyboardshortcut',
-        {
-            'key': {
-                'key_code': 76,
-                'char': 'l'
-            }
-        },
-        category_label=PREF_LABEL_KEYBOARD_SHORTCUTS,
-        fields=accesskey_fields
-    )
-
     self.preference.register(
         'keyboard_shortcuts', 'btn_conn_status',
         gettext('Accesskey (Connection status)'), 'keyboardshortcut',
diff --git a/web/pgadmin/tools/sqleditor/utils/start_running_query.py b/web/pgadmin/tools/sqleditor/utils/start_running_query.py
index 876c1e8d5..b2a001236 100644
--- a/web/pgadmin/tools/sqleditor/utils/start_running_query.py
+++ b/web/pgadmin/tools/sqleditor/utils/start_running_query.py
@@ -107,8 +107,6 @@ class StartRunningQuery:
             data={
                 'status': status, 'result': result,
                 'can_edit': can_edit, 'can_filter': can_filter,
-                'info_notifier_timeout':
-                    self.blueprint_object.info_notifier_timeout.get() * 1000,
                 'notifies': notifies,
                 'transaction_status': trans_status,
             }
diff --git a/web/pgadmin/tools/sqleditor/utils/tests/test_is_query_resultset_updatable.py b/web/pgadmin/tools/sqleditor/utils/tests/test_is_query_resultset_updatable.py
index c6840df63..9839472ec 100644
--- a/web/pgadmin/tools/sqleditor/utils/tests/test_is_query_resultset_updatable.py
+++ b/web/pgadmin/tools/sqleditor/utils/tests/test_is_query_resultset_updatable.py
@@ -203,7 +203,7 @@ class TestQueryUpdatableResultset(BaseTestGenerator):
 
     def _initialize_query_tool(self):
         self.trans_id = str(random.randint(1, 9999999))
-        url = '/datagrid/initialize/query_tool/{0}/{1}/{2}/{3}'.format(
+        url = '/sqleditor/initialize/sqleditor/{0}/{1}/{2}/{3}'.format(
             self.trans_id, utils.SERVER_GROUP, self.server_id, self.db_id)
         response = self.tester.post(url)
         self.assertEqual(response.status_code, 200)
@@ -235,7 +235,7 @@ class TestQueryUpdatableResultset(BaseTestGenerator):
         utils.create_table_with_query(self.server, self.db_name, create_sql)
 
     def _close_query_tool(self):
-        url = '/datagrid/close/{0}'.format(self.trans_id)
+        url = '/sqleditor/close/{0}'.format(self.trans_id)
         response = self.tester.delete(url)
         self.assertEqual(response.status_code, 200)
 
diff --git a/web/pgadmin/tools/sqleditor/utils/tests/test_save_changed_data.py b/web/pgadmin/tools/sqleditor/utils/tests/test_save_changed_data.py
index 0bef9b947..1b888d285 100644
--- a/web/pgadmin/tools/sqleditor/utils/tests/test_save_changed_data.py
+++ b/web/pgadmin/tools/sqleditor/utils/tests/test_save_changed_data.py
@@ -921,7 +921,7 @@ class TestSaveChangedData(BaseTestGenerator):
 
     def _initialize_query_tool(self):
         self.trans_id = str(random.randint(1, 9999999))
-        url = '/datagrid/initialize/query_tool/{0}/{1}/{2}/{3}'.format(
+        url = '/sqleditor/initialize/sqleditor/{0}/{1}/{2}/{3}'.format(
             self.trans_id, utils.SERVER_GROUP, self.server_id, self.db_id)
         response = self.tester.post(url)
         self.assertEqual(response.status_code, 200)
@@ -955,6 +955,6 @@ class TestSaveChangedData(BaseTestGenerator):
         utils.create_table_with_query(self.server, self.db_name, create_sql)
 
     def _close_query_tool(self):
-        url = '/datagrid/close/{0}'.format(self.trans_id)
+        url = '/sqleditor/close/{0}'.format(self.trans_id)
         response = self.tester.delete(url)
         self.assertEqual(response.status_code, 200)
diff --git a/web/pgadmin/tools/sqleditor/utils/tests/test_start_running_query.py b/web/pgadmin/tools/sqleditor/utils/tests/test_start_running_query.py
index 9c8e0e470..c884f3f10 100644
--- a/web/pgadmin/tools/sqleditor/utils/tests/test_start_running_query.py
+++ b/web/pgadmin/tools/sqleditor/utils/tests/test_start_running_query.py
@@ -112,7 +112,6 @@ class StartRunningQueryTest(BaseTestGenerator):
                             'not found.',
                      can_edit=False,
                      can_filter=False,
-                     info_notifier_timeout=5000,
                      notifies=None,
                      transaction_status=None
                  )
@@ -273,7 +272,6 @@ class StartRunningQueryTest(BaseTestGenerator):
                      result='async function result output',
                      can_edit=True,
                      can_filter=True,
-                     info_notifier_timeout=5000,
                      notifies=None,
                      transaction_status=None
                  )
@@ -318,7 +316,6 @@ class StartRunningQueryTest(BaseTestGenerator):
                      result='async function result output',
                      can_edit=True,
                      can_filter=True,
-                     info_notifier_timeout=5000,
                      notifies=None,
                      transaction_status=None
                  )
@@ -363,7 +360,6 @@ class StartRunningQueryTest(BaseTestGenerator):
                      result='async function result output',
                      can_edit=True,
                      can_filter=True,
-                     info_notifier_timeout=5000,
                      notifies=None,
                      transaction_status=None
                  )
@@ -409,7 +405,6 @@ class StartRunningQueryTest(BaseTestGenerator):
                      result='async function result output',
                      can_edit=True,
                      can_filter=True,
-                     info_notifier_timeout=5000,
                      notifies=None,
                      transaction_status=None
                  )
@@ -444,8 +439,7 @@ class StartRunningQueryTest(BaseTestGenerator):
         if self.expect_internal_server_error_called_with is not None:
             internal_server_error_mock.return_value = expected_response
         pickle_mock.loads.return_value = self.pickle_load_return
-        blueprint_mock = MagicMock(
-            info_notifier_timeout=MagicMock(get=lambda: 5))
+        blueprint_mock = MagicMock()
 
         # Save value for the later use
         self.is_begin_required_for_sql_query = \
diff --git a/web/pgadmin/utils/constants.py b/web/pgadmin/utils/constants.py
index 9873371d2..35a5ed51d 100644
--- a/web/pgadmin/utils/constants.py
+++ b/web/pgadmin/utils/constants.py
@@ -34,6 +34,7 @@ SERVER_CONNECTION_CLOSED = gettext(
 
 # Query tool placeholder
 QT_DEFAULT_PLACEHOLDER = '%DATABASE%/%USERNAME%@%SERVER%'
+VW_EDT_DEFAULT_PLACEHOLDER = '%SCHEMA%.%TABLE%/%DATABASE%/%USERNAME%@%SERVER%'
 
 # Data Types
 DATATYPE_TIME_WITH_TIMEZONE = 'time with time zone'
diff --git a/web/pgadmin/utils/csrf.py b/web/pgadmin/utils/csrf.py
index f88cbf58e..7ad14eebe 100644
--- a/web/pgadmin/utils/csrf.py
+++ b/web/pgadmin/utils/csrf.py
@@ -31,8 +31,9 @@ class _PGCSRFProtect(CSRFProtect):
             'pgadmin.tools.translations',
             app.blueprints['redirects'],
             'pgadmin.browser.server_groups.servers.supported_servers-js',
-            'pgadmin.tools.datagrid.initialize_query_tool',
+            'pgadmin.tools.sqleditor.initialize_sqleditor',
             'pgadmin.tools.datagrid.panel',
+            'pgadmin.tools.sqleditor.panel',
             'pgadmin.tools.debugger.initialize_target',
             'pgadmin.tools.debugger.direct_new',
             'pgadmin.tools.schema_diff.panel',
diff --git a/web/regression/javascript/components/CodeMirror.spec.js b/web/regression/javascript/components/CodeMirror.spec.js
index 7e8d8f248..6cec715d4 100644
--- a/web/regression/javascript/components/CodeMirror.spec.js
+++ b/web/regression/javascript/components/CodeMirror.spec.js
@@ -52,9 +52,33 @@ describe('CodeMirror', ()=>{
       'setSelection': ()=>{/*This is intentional (SonarQube)*/},
       'scrollIntoView': ()=>{/*This is intentional (SonarQube)*/},
       'getWrapperElement': document.createElement('div'),
+      'on': ()=>{/*This is intentional (SonarQube)*/},
     });
   beforeEach(()=>{
     jasmineEnzyme();
+    window.pgAdmin = {
+      Browser: {
+        Events: {
+          on: jasmine.createSpy('on'),
+        },
+        get_preferences_for_module: ()=>({}),
+        docker: {
+          findPanels: function() {
+            return [
+              {
+                isVisible: function() {
+                  return true;
+                },
+              },
+            ];
+          },
+        },
+        onPreferencesChange: ()=>{/*This is intentional (SonarQube)*/},
+        utils: {
+          app_version_int: 1234,
+        },
+      },
+    };
     spyOn(OrigCodeMirror, 'fromTextArea').and.returnValue(cmObj);
     const ThemedCM = withTheme(CodeMirror);
     cmInstance = mount(
@@ -65,6 +89,10 @@ describe('CodeMirror', ()=>{
       />);
   });
 
+  afterEach(()=>{
+    window.pgAdmin = undefined;
+  });
+
   it('init', ()=>{
     /* textarea ref passed to fromTextArea */
     expect(OrigCodeMirror.fromTextArea).toHaveBeenCalledWith(cmInstance.find('textarea').getDOMNode(), jasmine.objectContaining(options));
diff --git a/web/regression/javascript/components/ShortcutTitle.spec.js b/web/regression/javascript/components/ShortcutTitle.spec.js
index a88f9d7ad..1508bba07 100644
--- a/web/regression/javascript/components/ShortcutTitle.spec.js
+++ b/web/regression/javascript/components/ShortcutTitle.spec.js
@@ -57,7 +57,6 @@ describe('ShortcutTitle', ()=>{
   });
 
   describe('shortcutToString', ()=>{
-
     it('shortcut', ()=>{
       spyOn(keyShort, 'isMac').and.returnValue(false);
       expect(shortcutToString(shortcut)).toBe('Ctrl + Shift + K');
@@ -69,6 +68,7 @@ describe('ShortcutTitle', ()=>{
     });
 
     it('accesskey', ()=>{
+      spyOnProperty(window.navigator, 'userAgent').and.returnValue('Unknown');
       expect(shortcutToString(null, 'A')).toEqual('Accesskey + A');
     });
 
diff --git a/web/regression/javascript/erd/ui_components/body_widget_spec.js b/web/regression/javascript/erd/ui_components/body_widget_spec.js
index 19eb0d34f..74afced32 100644
--- a/web/regression/javascript/erd/ui_components/body_widget_spec.js
+++ b/web/regression/javascript/erd/ui_components/body_widget_spec.js
@@ -9,7 +9,7 @@ import ERDCore from 'pgadmin.tools.erd/erd_tool/ERDCore';
 import * as erdModule from 'pgadmin.tools.erd/erd_module';
 import erdPref from './erd_preferences';
 import BodyWidget from 'pgadmin.tools.erd/erd_tool/ui_components/BodyWidget';
-import * as ERDSqlTool from 'tools/datagrid/static/js/show_query_tool';
+import * as ERDSqlTool from 'tools/sqleditor/static/js/show_query_tool';
 import { FakeLink, FakeNode, FakePort } from '../fake_item';
 import Notify from '../../../../pgadmin/static/js/helpers/Notifier';
 
@@ -42,6 +42,9 @@ let pgAdmin = {
     init: jasmine.createSpy(),
     show_dialog: jasmine.createSpy(),
   },
+  Tools: {
+    SQLEditor: {},
+  }
 };
 
 let pgWindow = {
diff --git a/web/regression/javascript/fake_endpoints.js b/web/regression/javascript/fake_endpoints.js
index ddd50fb8b..fd5ec175f 100644
--- a/web/regression/javascript/fake_endpoints.js
+++ b/web/regression/javascript/fake_endpoints.js
@@ -14,11 +14,11 @@ define(function () {
     'sqleditor.query_tool_start': '/sqleditor/query_tool/start/<path:trans_id>',
     'backup.create_server_job':  '/backup/job/<int:sid>',
     'backup.create_object_job':  '/backup/job/<int:sid>/object',
-    'datagrid.initialize_datagrid': '/initialize/datagrid/<int:cmd_type>/<obj_type>/<int:sgid>/<int:sid>/<int:did>/<int:obj_id>',
-    'datagrid.initialize_query_tool': '/initialize/query_tool/<int:sgid>/<int:sid>',
-    'datagrid.initialize_query_tool_with_did': '/initialize/query_tool/<int:sgid>/<int:sid>/<int:did>',
+    'sqleditor.initialize_viewdata': '/initialize/sqleditor/<int:cmd_type>/<obj_type>/<int:sgid>/<int:sid>/<int:did>/<int:obj_id>',
+    'sqleditor.initialize_sqleditor': '/initialize/sqleditor/<int:sgid>/<int:sid>',
+    'sqleditor.initialize_sqleditor_with_did': '/initialize/sqleditor/<int:sgid>/<int:sid>/<int:did>',
     'restore.create_job': '/restore/job/<int:sid>',
-    'datagrid.panel': '/panel/<int:trans_id>',
+    'sqleditor.panel': '/panel/<int:trans_id>',
     'search_objects.types': '/search_objects/types/<int:sid>/<int:did>',
     'search_objects.search': '/search_objects/search/<int:sid>/<int:did>',
     'dashboard.dashboard_stats': '/dashboard/dashboard_stats',
diff --git a/web/regression/javascript/sqleditor_utils_spec.js b/web/regression/javascript/sqleditor_utils_spec.js
index 29e9855ea..886625769 100644
--- a/web/regression/javascript/sqleditor_utils_spec.js
+++ b/web/regression/javascript/sqleditor_utils_spec.js
@@ -10,25 +10,6 @@
 define(['sources/sqleditor_utils'],
   function (SqlEditorUtils) {
     describe('SqlEditorUtils', function () {
-
-      describe('Generate a random string of size 10', function () {
-        it('returns string of length 10', function () {
-          expect(SqlEditorUtils.epicRandomString(10).length).toEqual(10);
-        });
-      });
-
-      describe('Generate a unique hash for given string', function () {
-        it('returns unique hash', function () {
-          expect(SqlEditorUtils.getHash('select * from test')).toEqual(403379630);
-        });
-      });
-
-      describe('Capitalize the first letter of given string', function () {
-        it('returns string with First letter Capital', function () {
-          expect(SqlEditorUtils.capitalizeFirstLetter('create script')).toEqual('Create script');
-        });
-      });
-
       describe('Calculate font size of input number passed', function () {
         it('calcFontSize', function () {
           expect(SqlEditorUtils.calcFontSize(1.456)).toEqual('1.46em');
diff --git a/web/webpack.config.js b/web/webpack.config.js
index ed9ad4472..66e39f500 100644
--- a/web/webpack.config.js
+++ b/web/webpack.config.js
@@ -374,7 +374,7 @@ module.exports = [{
     'app.bundle': sourceDir + '/bundle/app.js',
     codemirror: sourceDir + '/bundle/codemirror.js',
     slickgrid: sourceDir + '/bundle/slickgrid.js',
-    sqleditor: './pgadmin/tools/sqleditor/static/js/sqleditor.js',
+    sqleditor: './pgadmin/tools/sqleditor/static/js/index.js',
     debugger_direct: './pgadmin/tools/debugger/static/js/direct.js',
     schema_diff: './pgadmin/tools/schema_diff/static/js/schema_diff_hook.js',
     erd_tool: './pgadmin/tools/erd/static/js/erd_tool_hook.js',
@@ -463,7 +463,7 @@ module.exports = [{
       // var jQuery = require('jquery'); var browser = require('pgadmin.browser')
       // It solves number of problems
       // Ref: http:/github.com/webpack-contrib/imports-loader/
-      test: require.resolve('./pgadmin/tools/datagrid/static/js/datagrid'),
+      test: require.resolve('./pgadmin/tools/sqleditor/static/js/index'),
       use: {
         loader: 'imports-loader',
         options: {
@@ -564,6 +564,7 @@ module.exports = [{
             'pure|pgadmin.tools.search_objects',
             'pure|pgadmin.tools.erd_module',
             'pure|pgadmin.tools.psql_module',
+            'pure|pgadmin.tools.sqleditor',
             'pure|pgadmin.misc.cloud',
           ],
         },
